#include<iostream>
#include<string>
using namespace std;

class Hallgato{
public:
    string nev;
    int pontszam;

    Hallgato(string nev, int pontszam) : nev(nev), pontszam(pontszam){ cout << "create" << endl; }
    Hallgato(Hallgato& h) : nev(h.nev), pontszam(h.pontszam){ cout << "copy" << endl; }

    friend ostream& operator<<(ostream& os, Hallgato& h){
        os << h.nev << ", " << h.pontszam << endl;
        return os;
    }
};

class Csoport{
private:
    Hallgato** hallgatok;
    int max;    // a tomb merete
    int jelenlegi; // kovetkezo ures elem indexe
public:
    Csoport(int letszam): max(letszam), jelenlegi(0) { // inicializaljuk a max adattagot, a jelenlegit beallitjuk 0-ra, ott a kovetkezo ures index
        hallgatok = new Hallgato*[letszam]; // Letrehozzuk a tombot
    }

    //Konnyen atvarialhatjuk az addHallgato fuggvenyt += operatorra:
    //void operator+=(Hallgato& h){
    void addHallgato(Hallgato& h){
        if (this->jelenlegi == this->max){ // Ha a kovetkezo ures index a tomb meretevel egyezik meg, akkor nincs mar hely (10 elem eseten 0-9-ig vannak indexek, a 10. index mar nem resze a tombnek)
            return;
        }
        // Ha van hely, beletesszuk a tombbe
        // Hallgato referenciakent erkezik
        this->hallgatok[this->jelenlegi] = new Hallgato(h); // Masolatot keszitunk a copy konstruktorral. A new operator okan az uj objektum a heapen jon letre es pointert ad vissza, ami nekunk pont jo!
        // A jelenlegi elso ures helyen mar van valaki, eggyel arrebb kell lokni a mutatot.
        this->jelenlegi++;
    }

    // Mivel a tombot is dinamikusan foglaltuk es a tomb elemeit is egyesevel atmasoltuk, ezert a felszabaditas is a mi feladatunk
    ~Csoport(){
        for (int i = 0; i < this->jelenlegi; i++) {  // Toroljuk az elemeket, de cska annyit, amennyit atmasoltunk
            delete this->hallgatok[i]; // Minden egyes elemet is kitorlunk
            this->hallgatok[i] = nullptr; // Biztos, ami biztos beallitjuk null pointerre a torolt elemre valo hivatkozast, nehogy veletlen hozza akarjunk ferni
        }
        delete[] this->hallgatok; // Toroljuk a tombot, ami az elemeket tarolja
    }


    Hallgato operator[](int index){
        if (index < this->jelenlegi && index >= 0){
            return *(this->hallgatok[index]);  // Dereferaljuk az objektumot. Ez igy jo lesz, mert visszaadaskor a parameter masolatat adjuk vissza.
        } 
        return Hallgato("nincs", -1);
    }
};


int main(){
    Hallgato elso("Elso hallgato", 10);
    Hallgato masodik("Masodik", 12);

    Csoport cs(5);
    cs.addHallgato(elso);
    cs.addHallgato(masodik);
    cout << cs[0] << endl;

    return 0;
}